﻿using System;

namespace TP12
{
	class MainClass
	{
		public static int Main(string[] args)
		{
			if (checkHelp(args))
				return 0;


			Map map = new Map(30, 20);


			if (args.Length > 0)
			{
				int index = 0;
				for (int i = 0; i < 2; i++)
				{
					Input input;
					if (index >= args.Length)
						index = 0;
					if (args[index] == "-")
						input = new KeyboardInput();
					else
					{
						string filename = args[index];
						int timeout;
						if (index + 1 >= args.Length || !Int32.TryParse(args[index + 1], out timeout))
							timeout = 100;
						else
							index++;
						input = new ProgramInput(filename, map, 10 + i * 10, 10, timeout);
					}
					index++;
					map.AddPlayer(new Player(input, 10 + i * 10, 10));
				}
			}
			else
			{
				map.AddPlayer(new Player(new KeyboardInput(), 10, 10));
				map.AddPlayer(new Player(new KeyboardInput(ConsoleKey.W,
															  ConsoleKey.S,
														   ConsoleKey.A,
														   ConsoleKey.D)
										 , 20, 10));
			}
			int winner = 0;
			do
			{
				map.Display();
				System.Threading.Thread.Sleep(100);
				KeyboardInput.UpdateKey();
				winner = map.Update();
			} while (winner == 0);
			if (winner > 0)
			{
				Console.ForegroundColor = ConsoleColor.Green;
				Console.WriteLine("\n\nPlayer {0} wins !", winner);
				return winner > 1 ? 1 : -1;
			}
			else
			{
				Console.ForegroundColor = ConsoleColor.Red;
				Console.WriteLine("\n\nNo players on the map, nobody wins");
				return 0;
			}
		}

		private static bool checkHelp(String[] args)
		{
			foreach (String arg in args)
			{
				if (arg == "--help" || arg == "-h")
				{
					Console.WriteLine("Usage: ./Tron AI_1 AI_2... [Timeout]");
					Console.WriteLine("Replace an argument by a '-' to play with WASD");
					return true;
				}
			}
			return false;
		}
	}
}
